# Zach Gildersleeve
# zgildersleeve@gmail.com
# CS6630 - Scientific Visualization
# Project 1
# Sept. 26, 2006
#
# mtHoodWarp.tcl - This script reads in the Mt. Hood dataset and warps
# geometry based on the data's grayscale values.  An appropriate scale
# factor is provided.


catch {load vtktcl}
set VTK_TCL ".."
set VTK_DATA "../vtkdata"

vtkLookupTable RGBlut
  	RGBlut SetNumberOfColors 256
 	 RGBlut SetTableRange 0 255
  	for {set i 0} {$i <= 255} {incr i} {
    		RGBlut SetTableValue $i 0 0 0 1.0
  	}

vtkPNMReader reader
	reader SetFileName $VTK_DATA/MtHood.pgm

vtkImageMagnitude magnitude
	magnitude SetInput [reader GetOutput]

vtkImageDataGeometryFilter geometry
	geometry SetInput [magnitude GetOutput]

vtkWarpScalar warp
	warp SetInput [geometry GetOutput]
	warp SetScaleFactor 0.25

vtkMergeFilter merge
	merge SetGeometry [warp GetOutput]
	merge SetScalars [reader GetOutput]

vtkDataSetMapper mapper
	mapper SetInput [merge GetOutput]
	mapper SetLookupTable RGBlut

vtkActor actor
	actor SetMapper mapper

vtkRenderer ren1
vtkRenderWindow renWin
	renWin AddRenderer ren1
vtkRenderWindowInteractor iren
	iren SetRenderWindow renWin

ren1 AddActor actor
ren1 SetBackground 0.5 0.5 0.5
ren1 ResetCamera

renWin SetSize 600 600

button .quit -text "Quit" -command {exit}
pack .quit

renWin Render