# Zach Gildersleeve
# zgildersleeve@gmail.com
# CS6630 - Scientific Visualization
# Project 1
# Sept. 26, 2006
#
# viewThorax.tcl - This script uses a vtkDelaunay2D method to tesselate
# the thoraxPoints.vtk vtkPolyData dataset. The Delaunay tolerance and
# alpha control the final look of the visualization.


catch {load vtktcl}
set VTK_TCL ".."
set VTK_DATA "../vtkdata"

vtkPolyDataReader reader
	reader SetFileName thoraxPoints.vtk
	reader OpenVTKFile

vtkDelaunay2D delaunay
delaunay SetInput [reader GetOutput]
delaunay SetTolerance 0.001
delaunay SetAlpha 18.0
delaunay Update

vtkPolyDataMapper mapper
	mapper SetInput [delaunay GetOutput]

vtkActor actor
	actor SetMapper mapper
	[actor GetProperty] SetColor 1.0 0.5 0.5

vtkRenderer ren1
vtkRenderWindow renWin
	renWin AddRenderer ren1
vtkRenderWindowInteractor iren
	iren SetRenderWindow renWin

ren1 AddActor actor
ren1 SetBackground 0.5 0.5 0.5
ren1 ResetCamera

renWin SetSize 600 600

button .quit -text "Quit" -command {exit}
pack .quit

renWin Render