# Zach Gildersleeve
# zgildersleeve@gmail.com
# CS6630 - Scientific Visualization
# Project 1
# Sept. 26, 2006
#
# writepoints.tcl - This script, based on a provided "writepoints.tcl",
# pulls data from assignment1.pts, a set of (x, y, z) coordinates,
# discards the z position, and uses the matching electric field potential
# from assignment1.data to create a vtkPolyData dataset.


catch {load vtktcl}

set VTK_DATA "../vtkdata"
set INPUT_FILE_POINTS "$VTK_DATA/assignment1.pts"
set INPUT_FILE_DATA "$VTK_DATA/assignment1.data"
set OUTPUT_FILE "thoraxPoints.vtk"

set x [list]
set y [list]

# read in electric field data and interpret as 'z' coordinate data
if {![catch [set infile_data [open $INPUT_FILE_DATA "r"]]]} {
	puts stderr "Failed to open $INPUT_FILE_DATA for read\n"
	exit
}
set pointsAllData [read $infile_data]
close $infile_data
set z [split $pointsAllData "\n"]

# read in 'x' and 'y' data, and ignore 'z' data
if {![catch [set infile_points [open $INPUT_FILE_POINTS "r"]]]} {
	puts stderr "Failed to open $INPUT_FILE_POINTS for read\n"
	exit
}
set pointsAllContent [read $infile_points]
close $infile_points

set pointsLineContent [split $pointsAllContent "\n"]

foreach line $pointsLineContent {
	set point [regexp -inline -all -- {\S+} $line]
	lappend x [lindex $point 0]
	lappend y [lindex $point 1]
}

vtkPoints points

# pull data together, quit if empty string or NULL
for {set i 0} {$i < [llength $x] - 1} {incr i} {
	if {([lindex $x $i] == {}) || ([lindex $y $i] == {}) || ([lindex $z $i] == {})} {break}
	points InsertNextPoint [lindex $x $i] [lindex $y $i] [lindex $z $i]
}

vtkPolyData polydata
	polydata SetPoints points

vtkPolyDataWriter writer
	writer SetFileName $OUTPUT_FILE
	writer SetInput polydata
	writer Write

exit